<template>
  <div >

    <div class="card pt-2 mb-4">
      <div class="p-4 pb-4 flex">

        <div>
          <div class="mb-4">
            <div class="flex mb-2">
              <div class="font-normal text-80 w-1/4">ID</div><div>{{ priceListData.id }}</div>
            </div>
            <div class="flex mb-2">
              <div class="font-normal text-80 w-1/4">Klient</div><div>{{ priceListData.client.name }}</div>
            </div>
            <div class="flex mb-2">
              <div class="font-normal text-80 w-1/4">Typ cenníka</div><div>{{ priceListType }}</div>
            </div>
            <div class="flex mb-2">
              <div class="font-normal text-80 w-1/4">Vytvorené</div><div>{{ createdAt }}</div>
            </div>
          </div>

          <button v-if="!readonly" class="btn btn-default btn-primary" @click="openAddNailWindow()">Pridať klince</button>
          <button v-if="!readonly" class="btn btn-default btn-primary" @click="savePriceListItems()">Uložiť parametre</button>
          <button class="btn btn-default btn-primary" @click="copyPriceList()">Kopírovať cenník</button>
        </div>

        <div class="pr-8 pl-8 flex-1">
          <div class="font-normal text-80">Poznámky</div>
          <textarea class=" form-input-bordered" v-model="notes" cols="60" rows="6"></textarea>
        </div>


        <div class="">
          <button class="btn btn-default btn-primary" @click="savePriceListAndExport()">Export PDF</button>
          <div class="p-2">
            <div class="mt-2"><input type="checkbox" v-model="pdfShowNumberPerCarton"> Počet v kartóne</div>
            <div class="mt-2"><input type="checkbox" v-model="pdfShowNumberPerPallet"> Počet na palete</div>
          </div>
        </div>

      </div>
    </div>

    <div class="card pt-2">

      <div class="py-3 px-3">

        <div class="flex flex-wrap">
          <div
              v-for="wire in panel.fields[0].nailWires"
              :key="wire.id"
              class="m-2"
              style="white-space: nowrap;"
          >
              <input
                  type='checkbox'
                  :value="wire.id"
                  v-model="filterSelectedWires"
                  class="mr-2"
              >{{ wire.name }}
          </div>
        </div>

      </div>
      <div
        class="flex items-center py-3 border-b border-50"
      >

        <div class="flex items-center">
          <div class="px-3">
            <input type="checkbox" v-model="selectAllRows" @click="selectAllRows=!selectAllRows" class="checkbox">
          </div>
        </div>

        <div class="flex items-center ml-auto px-3">

          <!---->
          <div>
            <div class="flex items-center mr-3">
              <select v-model="actionType" class="form-control form-select mr-2">
                <option value="" disabled="disabled" selected="selected">Hromadná zmena</option>
                <option value="koeficient">Cenový koeficient</option>
                <option value="prirazka">Prirážka</option>
              </select>
              <button
                @click="openActionDialog()"
                data-testid="action-confirm"
                dusk="run-action-button"
                title="Vykonať akciu"
                class="btn btn-default btn-primary
                  flex
                  items-center
                  justify-center
                  px-3"
              >
                <svg xmlns="http://www.w3.org/2000/svg" width="20" height="20" viewBox="0 0 20 20" aria-labelledby="play" role="presentation" class="fill-current text-white" style="margin-left: 7px;"><path fill-rule="nonzero" d="M0 .213l15.925 9.77L0 19.79V.213zm2 3.574V16.21l10.106-6.224L2 3.786z"></path></svg>
              </button>
            </div>
            <div class="v-portal" transition="fade-transition" style="display: none;"></div>
          </div>
          <!---->

          <div dusk="delete-menu">
            <div class="v-popover ml-3 bg-30 hover:bg-40 rounded">
              <div class="trigger" style="display: inline-block;">
                <button
                  @click="openMultiDeleteDialog()"
                  type="button"
                  class="
                    px-3
                    py-2
                    rounded
                    active:outline-none
                    active:shadow-outline
                    focus:outline-none
                    focus:shadow-outline
                  "
                >
                    <svg xmlns="http://www.w3.org/2000/svg" width="20" height="20" viewBox="0 0 20 20" aria-labelledby="delete" role="presentation" class="fill-current text-80">
                      <path fill-rule="nonzero" d="M6 4V2a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2v2h5a1 1 0 0 1 0 2h-1v12a2 2 0 0 1-2 2H4a2 2 0 0 1-2-2V6H1a1 1 0 1 1 0-2h5zM4 6v12h12V6H4zm8-2V2H8v2h4zM8 8a1 1 0 0 1 1 1v6a1 1 0 0 1-2 0V9a1 1 0 0 1 1-1zm4 0a1 1 0 0 1 1 1v6a1 1 0 0 1-2 0V9a1 1 0 0 1 1-1z"></path>
                    </svg>
                </button>
              </div>
            </div> <!---->
          </div>

        </div>

      </div>

      <div class="relative">
        <div class="overflow-hidden overflow-x-auto relative" style="">

          <table cellpadding="0" cellspacing="0" data-testid="resource-table" class="table w-full table-default">

            <thead>
              <tr>
                <th class="w-16">&nbsp;</th>
                <th v-for="(headerItem,index) in priceListItemsHeader" :key="index"  class="text-left">
                    {{ headerItem.title }}
                </th>
                <th>&nbsp;</th>
              </tr>
            </thead>

            <tbody>
              <price-list-items-form-row
                v-for="(priceListItem,index) in priceListItems" :key="priceListItem.id"
                v-model="priceListItems[index]"
                :readonly="readonly"
                :constants="panel.fields[0].constants"
                :priceListType="priceListData.type"
                @delete-row="loadPriceListItems()"
              ></price-list-items-form-row>

            </tbody>
          </table>
        </div>

        <!--
        <div class="bg-20 rounded-b-lg" per-page="25" resource-count-label="1-8 z 8" current-resource-count="8" all-matching-resource-count="8"><nav class="flex items-center"><div class="flex text-sm"><button disabled="disabled" rel="first" dusk="first" class="font-mono btn btn-link h-9 min-w-9 px-2 border-r border-50 text-80 opacity-50">
        «
      </button> <button disabled="disabled" rel="prev" dusk="previous" class="font-mono btn btn-link h-9 min-w-9 px-2 border-r border-50 text-80 opacity-50">
        ‹
      </button> <button dusk="page:1" class="btn btn-link h-9 min-w-9 px-2 border-r border-50 text-80 opacity-50">
        1
      </button> <button disabled="disabled" rel="next" dusk="next" class="font-mono btn btn-link h-9 min-w-9 px-2 border-r border-50 text-80 opacity-50">
        ›
      </button> <button disabled="disabled" rel="last" dusk="last" class="font-mono btn btn-link h-9 min-w-9 px-2 border-r border-50 text-80 opacity-50">
        »
      </button></div> <span class="text-sm text-80 px-4 ml-auto">
          1-8 z 8
        </span></nav></div>
        -->
      </div>
    </div>


    <add-nails-window
      v-if="showAddNailWindow"
      :nailWires="panel.fields[0].nailWires"
      :nailFinishies="panel.fields[0].nailFinishies"
      :priceListId="resourceId"
      @close="closeAddNailWindow($event)"
    ></add-nails-window>

    <modal v-if="multiDeleteDialogShow" @modal-close="closeMultiDeleteDialog()">
      <div class="bg-white rounded-lg shadow-lg overflow-hidden text-left" style="">
              <div class="p-8">
                  <heading :level="2" class="mb-6 text-90 font-normal text-xl">Zmazanie záznamov z cenníka</heading>
                  <div class="text-100 container">
                      Naozaj chcete zmazať všetky vybrané položky z cenníka?
                  </div>
              </div>
              <div class="bg-30 px-6 py-3 flex">
                  <div class="flex items-center ml-auto">
                      <button
                              type="button"
                              class="btn text-80 font-normal h-9 px-3 mr-3 btn-link"
                              @click="closeMultiDeleteDialog()"
                      >
                          Zrušiť
                      </button>

                      <button
                          type="button"
                          class="btn btn-default btn-danger"
                          @click="deleteSelectedItems()"
                      >
                          Zmazať
                      </button>
                  </div>
              </div>

      </div>
    </modal>


    <modal v-if="actionDialogShow" @modal-close="closeActionDialog()">
      <div class="bg-white rounded-lg shadow-lg overflow-hidden text-left" style="">
              <div class="p-8">
                  <heading :level="2" class="mb-6 text-90 font-normal text-xl">Hromadná úprava</heading>
                  <div v-show="actionType=='koeficient'" class="text-100 container">
                      Cenový koeficient: <input v-model="actionValue" type="number" step="0.01" min="0" class="form-control form-input form-input-bordered w-40">
                  </div>
                  <div v-show="actionType=='prirazka'" class="text-100 container">
                      Prirážka: <input v-model="actionValue" type="number" step="1" min="0" class="form-control form-input form-input-bordered w-40">
                  </div>
              </div>
              <div class="bg-30 px-6 py-3 flex">
                  <div class="flex items-center ml-auto">
                      <button
                              type="button"
                              class="btn text-80 font-normal h-9 px-3 mr-3 btn-link"
                              @click="closeActionDialog()"
                      >
                          Zrušiť
                      </button>

                      <button
                          type="button"
                          class="btn btn-default btn-primary"
                          @click="doAction()"
                      >
                          Vykonať akciu
                      </button>
                  </div>
              </div>

      </div>
    </modal>


  </div>

</template>

<script>
import AddNailsWindow from './AddNailsWindow.vue'
import PriceListItemsFormRow from './PriceListItemsFormRow.vue'

export default {
  components: {AddNailsWindow, PriceListItemsFormRow},
  props: ['resourceName', 'resourceId', 'panel'],
  data: () => ({
    showAddNailWindow: false,
    priceListData: {client: {}},
    priceListItems: [],
    pdfShowNumberPerCarton: false,
    pdfShowNumberPerPallet: false,
    notes: '',
    selectAllRows: false,
    multiDeleteDialogShow: false,
    filterSelectedWires: [],
    actionDialogShow: false,
    actionType: '',
    actionValue: '',
  }),
  watch: {
    selectAllRows(newVal, oldVal) {
      if (newVal!=oldVal) {
        this.priceListItems.forEach(item => {
          item.selected = newVal
        })
      }
    },
    filterSelectedWires: _.debounce(function () {
      this.savePriceListItems(()=>{
        this.loadPriceListItems()
      }, true)
    }, 1000)
  },
  computed: {
    priceListItemsHeader() {

      let priceTitle = ""

      if (this.priceListData.type == 'welded') {
        priceTitle = 'Cena za 1000 ks [eur]'
      }
      if (this.priceListData.type == 'loose') {
        priceTitle = 'Cena za kg [eur]'
      }

      return [
        {title: 'Klinec'},
        {title: 'Váha 1000 ks [kg]'},
        {title: 'Cena drôtu [eur/t]'},
        {title: 'Cenový koeficient'},
        {title: 'Prirážka [%]'},
        {title: priceTitle},
      ]

    },
    priceListType () {
      let type = '-'
      if (this.priceListData.type == 'welded') {
        type = 'Zvárané'
      }
      if (this.priceListData.type == 'loose') {
        type = 'Voľne sypané'
      }
      return type
    },
    readonly () {
      return  !this.panel.fields[0].isLast
    },
    createdAt () {
      let cdate = new Date(this.priceListData.created_at)
      return cdate.getDate().toString().padStart(2, '0') + '.' + (cdate.getMonth()+1).toString().padStart(2, '0') + '.' + cdate.getFullYear() + ' ' + cdate.getHours().toString().padStart(2, '0') + ':' + cdate.getMinutes().toString().padStart(2, '0')
    }
  },
  methods: {
    openActionDialog() {
      let selectedRows = []
      this.priceListItems.forEach(item => {
        if (item.selected) {
          selectedRows.push(item.id)
        }
      })

      if (selectedRows.length>0) {
        this.actionDialogShow = true
      } else {
        this.$toasted.error('Neboli vybrané žiadne záznamy.');
      }

    },
    closeActionDialog() {
        this.actionDialogShow = false
    },
    doAction() {
      let selectedRows = []
      this.priceListItems.forEach(item => {
        if (item.selected) {
          selectedRows.push(item.id)
        }
      })

      let data = {
        priceListItemIds: selectedRows,
        actionType: this.actionType,
        actionValue: this.actionValue,
      }


      Nova.request().post('/nova-vendor/price-list-items-form/action-price-list-items', data)
        .then(response => {
          this.selectAllRows = false
          this.actionType = ''
          this.actionValue = ''
          this.loadPriceListItems()
          this.closeActionDialog()
        })

    },
    openMultiDeleteDialog() {
      let selectedRows = []
      this.priceListItems.forEach(item => {
        if (item.selected) {
          selectedRows.push(item.id)
        }
      })

      if (selectedRows.length>0) {
        this.multiDeleteDialogShow = true
      } else {
        this.$toasted.error('Neboli vybrané žiadne záznamy.');
      }

    },
    closeMultiDeleteDialog() {
        this.multiDeleteDialogShow = false
    },
    deleteSelectedItems() {
      let selectedRows = []
      this.priceListItems.forEach(item => {
        if (item.selected) {
          selectedRows.push(item.id)
        }
      })

      let config = {
        data: {
            priceListItemIds: selectedRows
        }
      }

      Nova.request().delete('/nova-vendor/price-list-items-form/delete-price-list-item', config)
        .then(response => {
          this.selectAllRows = false
          this.loadPriceListItems()
          this.closeMultiDeleteDialog()
        })

    },
    openAddNailWindow() {
      this.showAddNailWindow = true;
    },
    closeAddNailWindow(refresh) {
      if (refresh === true) {
        this.loadPriceListItems()
      }
      this.showAddNailWindow = false;

    },
    copyPriceList () {
        Nova.request().get('/nova-vendor/price-list-items-form/copy-price-list?priceListId=' + this.resourceId)
            .then(response => {
                window.location.href = response.data
            })
    },
    loadPriceListItems () {
        this.priceListItems = [];

        Nova.request().post('/nova-vendor/price-list-items-form/get-price-list-items',
          {
            priceListId: this.resourceId,
            filterSelectedWires: this.filterSelectedWires,
          }
        ).then(response => {
            this.priceListItems = response.data.map(obj => {
              let rObj = obj
              rObj.selected = false
              return rObj
            })
        })
    },
    savePriceListItems(onSuccess, silent) {
      let data = {}
      data.priceListId = this.resourceId
      data.priceListItems = this.priceListItems
      data.notes = this.notes
      data.pdfShowNumberPerCarton = this.pdfShowNumberPerCarton
      data.pdfShowNumberPerPallet = this.pdfShowNumberPerPallet

      Nova.request()
        .post('/nova-vendor/price-list-items-form/save-price-list-items', data)
        .then(response => {
          if (!silent) {
            this.$toasted.success('Parametre boli úspešne uložené.')
          }

          if (typeof onSuccess == "function") {
            onSuccess(response)
          }
        })
    },
    savePriceListAndExport() {
      this.savePriceListItems((response) => {
        this.$toasted.success('Parametre boli úspešne uložené, prebieha export do PDF. Čakajte prosím.')
        this.exportPDF()
      }, true)
    },
    exportPDF() {
      let data = {}
      data.priceListId = this.resourceId

      Nova.request().post('/nova-vendor/price-list-items-form/get-price-list-pdf', data, {responseType: 'arraybuffer'})
            .then(response => {
                this.downloadFile(response)
            })
    },
    downloadFile(response) {
      // It is necessary to create a new blob object with mime-type explicitly set
      // otherwise only Chrome works like it should
      var filename = response.headers['content-disposition'].split('=')[1].replace(/^\"+|\"+$/g, '')

      var newBlob = new Blob([response.data], {type: 'application/pdf'})

      // IE doesn't allow using a blob object directly as link href
      // instead it is necessary to use msSaveOrOpenBlob
      if (window.navigator && window.navigator.msSaveOrOpenBlob) {
        window.navigator.msSaveOrOpenBlob(newBlob)
        return
      }

      // For other browsers:
      // Create a link pointing to the ObjectURL containing the blob.
      const data = window.URL.createObjectURL(newBlob)
      var link = document.createElement('a')
      link.href = data
      link.download = filename
      link.click()
      setTimeout(function () {
        // For Firefox it is necessary to delay revoking the ObjectURL
        window.URL.revokeObjectURL(data)
      }, 100)
    },
  },
  mounted() {
    this.panel.fields[0].nailWires.forEach(wireItem =>{
      this.filterSelectedWires.push(wireItem.id)
    })

    // nastavenie filtra sposobi spustenie udalosti loadpricelistitems
    //this.loadPriceListItems()

    this.priceListData = this.panel.fields[0].priceListData
    this.pdfShowNumberPerCarton = this.panel.fields[0].priceListData.pdf_show_number_per_carton
    this.pdfShowNumberPerPallet = this.panel.fields[0].priceListData.pdf_show_number_per_pallet
    this.notes = this.panel.fields[0].priceListData.notes

  },
}
</script>
